/*
  Copyright (C) 2012  Torsten Brischalle

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/
*/

#ifndef LUA_TABLE_FUNC_H
#define LUA_TABLE_FUNC_H

//-----------------------------------------------------------------------------

#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>

#include <QString>

//-----------------------------------------------------------------------------

typedef struct lua_table_property_s
{
  const char    *name;
  lua_CFunction read;
  lua_CFunction write;
} lua_table_property;

//-----------------------------------------------------------------------------

typedef struct lua_table_function_s
{
  const char    *name;
  lua_CFunction func;
} lua_table_function;

//-----------------------------------------------------------------------------

void lua_global_table_begin(lua_State *lua,
                            const char *table_name);

void lua_global_table_end(lua_State *lua,
                          const char *table_name,
                          const lua_table_function *func_list,
                          const lua_table_property *prop_list);

//-----------------------------------------------------------------------------

void lua_sub_table_begin(lua_State *lua,
                         const char *table_name);

void lua_sub_table_end(lua_State *lua,
                       const char *table_name,
                       const lua_table_function *func_list,
                       const lua_table_property *prop_list);

//-----------------------------------------------------------------------------

void lua_set_global_function(lua_State *lua, lua_CFunction func, const char *funcName);

//-----------------------------------------------------------------------------

QString lua_get_table_str(lua_State *lua, int tableIdx, const char *fieldName);

//-----------------------------------------------------------------------------

#endif
