/*
  Copyright (C) 2012  Torsten Brischalle

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/
*/

#ifndef VARIABLELIST_H
#define VARIABLELIST_H

//-----------------------------------------------------------------------------

#include <QString>
#include <QVariant>
#include <QList>
#include <QStringList>

#include "lua.h"

//-----------------------------------------------------------------------------

class Variable
{
public:
  typedef QList <Variable> list_type;

  QString   m_name;
  QString   m_type;
  QString   m_value;
  QVariant  m_key;   // only for tables
};

//-----------------------------------------------------------------------------

class VariableList
{
public:

  Variable::list_type m_varList;

  VariableList();

  void Clear();
  void GetGlobalVariables(lua_State *lua);
  void GetLocalVariables(lua_State *lua);
  void GetLocalVariablesFromPath(lua_State *lua, const QVariantList & path);
  void GetGlobalVariablesFromPath(lua_State *lua, const QVariantList & path);

private:
  QString LuaValueToQString(lua_State *lua, int idx);

  void GetVariablesFromPath(lua_State *lua, const QVariantList & path);
};

//-----------------------------------------------------------------------------

#endif // VARIABLELIST_H
