/*
  Copyright (C) 2012  Torsten Brischalle

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/
*/

#ifndef WINDOWFUNCTIONHELP_H
#define WINDOWFUNCTIONHELP_H

//-----------------------------------------------------------------------------

#include <QWidget>
#include <QAction>

//-----------------------------------------------------------------------------

namespace Ui {
  class WindowFunctionHelp;
}

//-----------------------------------------------------------------------------

class WindowFunctionHelp : public QWidget
{
  Q_OBJECT

public:
  explicit WindowFunctionHelp(QWidget *parent = 0);
  ~WindowFunctionHelp();

private:
  Ui::WindowFunctionHelp *ui;

  QAction *m_actionHome;
  QAction *m_actionBackward;
  QAction *m_actionForward;

private slots:
  void backwardAvailable(bool available);
  void forwardAvailable(bool available);
};

//-----------------------------------------------------------------------------

#endif // WINDOWFUNCTIONHELP_H
